import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

/* eslint-disable no-use-before-define */
import { writeFile } from 'fs';
import makethen from 'makethen';
const pWriteFile = makethen(writeFile);

const createElement = (send, id) => ({
  $: function () {
    var _$ = _asyncToGenerator(function* (selector) {
      const _ref = yield send('WebDriver:FindElement', {
        element: id,
        value: selector,
        using: 'css selector'
      }),
            value = _ref.value;

      return createElement(send, value.ELEMENT);
    });

    return function $(_x) {
      return _$.apply(this, arguments);
    };
  }(),
  $$: function () {
    var _$$ = _asyncToGenerator(function* (selector) {
      const values = yield send('WebDriver:FindElements', {
        element: id,
        value: selector,
        using: 'css selector'
      });
      return values.map(value => createElement(send, value.ELEMENT));
    });

    return function $$(_x2) {
      return _$$.apply(this, arguments);
    };
  }(),
  screenshot: function () {
    var _screenshot = _asyncToGenerator(function* (options = {}) {
      const result = yield send('WebDriver:TakeScreenshot', {
        id,
        full: false,
        hash: false
      });
      const buffer = Buffer.from(result.value, 'base64');

      if (typeof options.path === 'string') {
        yield pWriteFile(options.path, buffer);
      }

      return buffer;
    });

    return function screenshot() {
      return _screenshot.apply(this, arguments);
    };
  }()
});

export default createElement;